#ifndef MAIN_H
#define MAIN_H

#include <string>
#include <vector>

const std::string VERSION("1.0.0");

const unsigned int MAX_LONG_BUF_SIZE = 1024;
const unsigned int MAX_SHORT_BUF_SIZE = 64;
const unsigned int MAX_CLASS_NAME_SIZE = 20;
const unsigned int MAX_SECTION_NAME_SIZE = 15;
const unsigned int MAX_RATE = 1000000000;
const unsigned int MIN_RATE = 8;

//enum UnitType_IEC { BITS_IEC = 1, KBITS_IEC = 1024, MBITS_IEC = 1048576, BYTES_IEC = 8, KBYTES_IEC = 8192, MBYTES_IEC = 8388608 };
enum UnitType { BITS = 1, KBITS = 1000, MBITS = 1000000, BYTES = 8, KBYTES = 8000, MBYTES = 8000000 };
enum EnumTcFilterType { U32 = 1, FW = 2 };
enum TcQdiscType { HTB = 1, NOQDISC = 2, SFQ = 3, ESFQ = 4 };
enum LangType { EN = 1 , PL_UTF8 = 2 };
enum FileType { CONFTYPE = 1 , CLASSTYPE = 2 };
enum IptTargetType { IPT_ACCEPT = 1, IPT_RETURN = 2, IPT_DROP = 3, IPT_FALSE = 4 };
enum EnumStatsClassesType { SC_ALL = 1, SC_ACTIVE = 2, SC_WORKING = 3, SC_FALSE = 4 };
enum EnumStatsSumType { SS_TOP = 1, SS_BOTTOM = 2, SS_FALSE = 3 };
enum TcOperationType { TC_ADD = 1, TC_MOD = 2, TC_REP = 3, TC_DEL = 4 };

extern class IfacesMap *ifaces;
extern class Tests *test;
extern class Sys *sys;
extern class Talk *talk;
extern class Log log;

extern std::string g_section_name;
extern unsigned int g_section_id;
extern bool g_fallback_to_tc;
extern bool g_fallback_to_ipt;
extern EnumStatsClassesType g_stats_classes;
extern EnumStatsSumType g_stats_sum_position;

#endif

